import javafx.application.Application;
import javafx.stage.Stage;
import javafx.scene.Group;
//import javafx.scene.Cursor;
import javafx.scene.*;
import javafx.event.EventHandler;
import javafx.scene.paint.*;
import javafx.scene.shape.*;
import javafx.collections.*;
import javafx.geometry.Point2D;
import javafx.geometry.Bounds;
import javafx.scene.input.* ;
import javafx.scene.layout.Pane;
import java.lang.Math;

import java.io.File;
import java.io.IOException;
import javafx.embed.swing.SwingFXUtils;
import javafx.scene.image.WritableImage;
import javax.imageio.ImageIO;

import java.awt.image.BufferedImage;
import java.awt.Graphics2D;

public class Snapshot2 extends Application {
    public void start(Stage stage) {
	Pane mypane = new Pane();
 	Scene scene = new Scene(mypane, 400, 400);
   	Group grp = new Group();
	mypane.getChildren().add(grp);


 	grp.setTranslateX(scene.getWidth()/2);
	grp.setTranslateY(scene.getHeight()/2);
	double res = 96;
	grp.setScaleX(res);
	grp.setScaleY(res);

	Grid.draw(grp);

	grp.setOnMousePressed( e ->
	{
	    System.out.println("event type " + e.getEventType());
	    System.out.println("Local " + e.getX() + "  " + e.getY());
	}
	);

	Capacitor3 c1 =	new Capacitor3();
	c1.setPosition(-1.0,0.0);
	c1.draw(grp);

	Capacitor3 c2 = new Capacitor3();
	c2.setPosition(1.0,1.0);
	c2.setAngle(30.0);
	c2.draw(grp);
	

        stage.setTitle("Snapshot2");
        stage.setScene(scene);
        stage.show();
	takeSnapShot(scene);
	//takeSnapshot2(scene);
    }

    // works for png and gif, but not jpg
    private void takeSnapShot(Scene scene){
        WritableImage writableImage = 
            new WritableImage((int)scene.getWidth(), (int)scene.getHeight());
        scene.snapshot(writableImage);

	String ext = "png";
         
        File file = new File("snapshot2." + ext);
        try {
            ImageIO.write(SwingFXUtils.fromFXImage(writableImage, null), ext, file);
            System.out.println("snapshot saved: " + file.getAbsolutePath());
        } catch (IOException ex) {
	    System.out.println("snapshot failed");
	    System.out.println(ex);
        }
    }

    // works for jpg
    private void takeSnapshot2(Scene scene){
        WritableImage writableImage = 
            new WritableImage((int)scene.getWidth(), (int)scene.getHeight());
        scene.snapshot(writableImage);

	String ext = "jpg";
         
        File file = new File("snapshot2A." + ext);
        try {
		BufferedImage img = SwingFXUtils.fromFXImage(writableImage, null);
		// Remove alpha-channel from buffered image:
		BufferedImage imageRGB = 
  			new BufferedImage(
    				img.getWidth(), 
    				img.getHeight(), 
    				BufferedImage.OPAQUE); 

		Graphics2D graphics = imageRGB.createGraphics();

		graphics.drawImage(img, 0, 0, null);

            ImageIO.write(imageRGB, ext, file);
	    graphics.dispose();
            System.out.println("snapshot saved: " + file.getAbsolutePath());
        } catch (IOException ex) {
	    System.out.println("snapshot failed");
	    System.out.println(ex);
        }
    }

}